unit kreslic;

interface

uses types,shared,graph,crt;

procedure Prekresli;
procedure InitMap(menomapy:string);
procedure PolozHraca(var x,y:integer);
procedure PolozVec(var x,y,typ:integer);
procedure Say(Color:integer;S:String);
procedure mina(x,y:integer);
procedure Vybuch(x,y:integer);
procedure deton;
procedure efekt;

implementation

var spravy:array[0..60] of string[20];
    cspravy:array[0..60] of integer;
    riadkov:integer;
    oznam:boolean;

const o_black=0;  f_black='ICO\black.ico';
      o_kocky=1;  f_kocky='ICO\kocky.ico';
      o_kriz=2;   f_kriz='ICO\kriz.ico';
      o_skaly=3;  f_skaly='ICO\skaly.ico';
      o_sraf=4;   f_sraf='ICO\sraf.ico';
      o_sraf2=5;  f_sraf2='ICO\sraf2.ico';
      o_tehly=6;  f_tehly='ICO\tehly.ico';
      o_trava=7;  f_trava='ICO\grass.ico';
      o_u=8;      f_u='ICO\up.ico';
      o_d=9;      f_d='ICO\down.ico';
      o_l=10;     f_l='ICO\left.ico';
      o_r=11;     f_r='ICO\right.ico';
      o_ul=12;    f_ul='ICO\upleft.ico';
      o_ur=13;    f_ur='ICO\upright.ico';
      o_dl=14;    f_dl='ICO\downleft.ico';
      o_dr=15;    f_dr='ICO\downrajt.ico';
      o_1staid=16;f_1staid='ICO\1staid.ico';
      o_acbomb=17;f_acbomb='ICO\a-bomb.ico';
      o_bomb=18;  f_bomb='ICO\bomb.ico';
      o_boost=19; f_boost='ICO\booster.ico';
      o_acmine=20;f_acmine='ICO\mine.ico';
      o_mine=21;  f_mine='ICO\d-mine.ico';
      o_deton=22; f_deton='ICO\deton.ico';
      o_uzi=23;   f_uzi='ICO\uzi.ico';

var mapa:array[1..maxx,1..maxy] of record typ:byte; x:byte; end;
    veci:integer;
    obrazky:array[0..40,1..126] of byte;

procedure loadobr(x:byte; s:string);
var f:file;
begin
  assign(f,s);
  reset(f,1);
  blockread(f,obrazky[x],imagesize(1,1,15,15));
  close(f);
end;

procedure nacitaj_obr;
begin
  loadobr(o_black,f_black);
  loadobr(o_kocky,f_kocky);
  loadobr(o_kriz,f_kriz);
  loadobr(o_skaly,f_skaly);
  loadobr(o_sraf,f_sraf);
  loadobr(o_sraf2,f_sraf2);
  loadobr(o_tehly,f_tehly);
  loadobr(o_trava,f_trava);
  loadobr(o_u,f_u);
  loadobr(o_d,f_d);
  loadobr(o_l,f_l);
  loadobr(o_r,f_r);
  loadobr(o_ul,f_ul);
  loadobr(o_ur,f_ur);
  loadobr(o_dl,f_dl);
  loadobr(o_dr,f_dr);
  loadobr(o_1staid,f_1staid);
  loadobr(o_acbomb,f_acbomb);
  loadobr(o_bomb,f_bomb);
  loadobr(o_boost,f_boost);
  loadobr(o_acmine,f_acmine);
  loadobr(o_mine,f_mine);
  loadobr(o_deton,f_deton);
  loadobr(o_uzi,f_uzi);
end;

procedure Prekresli;
var i,j,q:integer;
    s:string;
    por:array[1..numberofplayers] of integer;

begin
  setcolor(15);
  if oznam then begin
     setfillstyle(1,0);
     bar(480,numberofplayers*32,639,479);
     for i:=1 to riadkov do begin
        setcolor(cspravy[i]);
        outtextxy(480,numberofplayers*32-8+i*8,spravy[i]);
     end;
     oznam:=false;
  end;
  for i:=1 to numberofplayers do por[i]:=i;
  for i:=1 to numberofplayers do
     for j:=1 to numberofplayers-1 do begin
        if players[por[j]].frag<players[por[j+1]].frag then begin
           q:=por[j];
           por[j]:=por[j+1];
           por[j+1]:=q;
        end;
        if players[por[j]].frag=players[por[j+1]].frag then
           if players[por[j]].lives<players[por[j+1]].lives then begin
           q:=por[j];
           por[j]:=por[j+1];
           por[j+1]:=q;
        end;
     end;
  setwritemode(xorput);
  for i:=1 to numberofplayers do
     if starestrely[i].t>0 then begin
        case starestrely[i].t of
        1:begin
             setlinestyle(1,0,3);
             setcolor(7);
          end;
        2,3:begin
             setlinestyle(1,0,3);
             setcolor(12);
            end;
        end;
        line(starestrely[i].x1*15-8,starestrely[i].y1*15-8,starestrely[i].x2*15-8,starestrely[i].y2*15-8);
     end;
  setlinestyle(0,0,1);
  setwritemode(normalput);
  setfillstyle(1,black);
  for i:=1 to numberofplayers do begin
     bar(480,i*32-32,549,i*32-1);
     bar(550,i*32-16,639,i*32-1);
     setcolor(1+(por[i]-1) mod 15);
     outtextxy(480,i*32-32,players[por[i]].name);
     str(players[por[i]].frag,s);
     outtextxy(480,i*32-16,'Frag:'+s);
     setcolor(darkgray);
     if i<numberofplayers then if players[por[i]].frag<>players[por[i+1]].frag then line(480,i*32-4,639,i*32-4);
     case players[por[i]].lives of
        0..2:setcolor(red);
        3..7:setcolor(yellow);
        8..10:setcolor(green);
        11..20:setcolor(lightgreen);
     end;
     line(480,i*32-20,480+players[por[i]].lives*3,i*32-20);
     line(480,i*32-21,480+players[por[i]].lives*3,i*32-21);
     setcolor(1+(por[i]-1) mod 15);
     str(players[por[i]].rations[uzi],s);
     outtextxy(550,i*32-16,s);
     str(players[por[i]].rations[mine],s);
     outtextxy(580,i*32-16,s);
     str(players[por[i]].rations[bomb],s);
     outtextxy(610,i*32-16,s);

  end;
  for j:=1 to maxy do for i:=1 to maxx do if change[i,j] then begin
     putimage(i*15-15,j*15-15,obrazky[mapa[i,j].typ mod 8],0);
     case things[i,j].who of
   who_player: begin
            case things[i,j].dx+1+3*(things[i,j].dy+1) of
            0: putimage(i*15-15,j*15-15,obrazky[o_ul],normalput);
            1: putimage(i*15-15,j*15-15,obrazky[o_u],normalput);
            2: putimage(i*15-15,j*15-15,obrazky[o_ur],normalput);
            3: putimage(i*15-15,j*15-15,obrazky[o_l],normalput);
            5: putimage(i*15-15,j*15-15,obrazky[o_r],normalput);
            6: putimage(i*15-15,j*15-15,obrazky[o_dl],normalput);
            7: putimage(i*15-15,j*15-15,obrazky[o_d],normalput);
            8: putimage(i*15-15,j*15-15,obrazky[o_dr],normalput);
            end;
            setcolor(1+((things[i,j].what-1) mod 15));
            rectangle(i*15-14,j*15-14,i*15-2,j*15-2);
          end;
   who_empty: case things[i,j].what of
       uzi: putimage(i*15-15,j*15-15,obrazky[o_uzi],normalput);
       mine: putimage(i*15-15,j*15-15,obrazky[o_mine],normalput);
       mine_active: putimage(i*15-15,j*15-15,obrazky[o_acmine],normalput);
       bomb: putimage(i*15-15,j*15-15,obrazky[o_bomb],normalput);
{       bomb_active: putimage(i*15-15,j*15-15,obrazky[o_acbomb],normalput);}
       aid: putimage(i*15-15,j*15-15,obrazky[o_1staid],normalput);
       booster: putimage(i*15-15,j*15-15,obrazky[o_boost],normalput);
       detonator: putimage(i*15-15,j*15-15,obrazky[o_deton],normalput);
      end;
      end;
     if bomby[i,j].time>0 then putimage(i*15-15,j*15-15,obrazky[o_acbomb],xorput);
  end;
  setwritemode(xorput);
  for i:=1 to numberofplayers do
     if strely[i].t>0 then begin
        case strely[i].t of
        1:begin
             setlinestyle(1,0,3);
             setcolor(7);
          end;
        2,3:begin
             setlinestyle(1,0,3);
             setcolor(12);
            end;
        end;
        line(strely[i].x1*15-8,strely[i].y1*15-8,strely[i].x2*15-8,strely[i].y2*15-8);
     end;
  setwritemode(normalput);
  setlinestyle(0,0,1);
  starestrely:=strely;
  fillchar(strely,sizeof(strely),nothing);
end;

function max(i,j:integer):integer;
begin
  if i>j then max:=i else max:=j;
end;

procedure PolozHraca(var x,y:integer);
var i,j,k,xx,yy,q:integer;
begin
  j:=-1000;
  for i:=1 to 50 do
  begin
    repeat
      x:=randy(maxx)+1;
      y:=randy(maxy)+1;
    until (things[x,y].who=who_empty) and (things[x,y].what=nothing) and not walls[x,y];
    q:=32767;
    for k:=1 to numberofplayers do begin
       if (players[k].lives>0) and
       (max(abs(players[k].x-x),abs(players[k].y-y))<q) then
      q:=max(abs(players[k].x-x),abs(players[k].y-y));
    end;

    if q>j then
    begin
      j:=q;
      xx:=x;
      yy:=y;
    end;
  end;
  y:=yy;
  x:=xx;
end;

procedure PolozVec(var x,y,typ:integer);
var i,j,k,l:integer;
begin
  l:=0;
  repeat
    inc(l);
    k:=randy(veci)+1;
    i:=0; j:=1;
    repeat
      inc(i);
      if i>maxx then
      begin
        i:=1;
        inc(j);
      end;
      if mapa[i,j].x>0 then dec(k);
    until k=0;
    x:=i;
    y:=j;
  until (things[i,j].who=who_empty) and (things[i,j].what=nothing) or (l=300);
  case randy(20) of
  0:typ:=booster;
  1:typ:=detonator;
  2..5:typ:=aid;
  6..9:typ:=bomb;
  10..13:typ:=mine;
  14..19:typ:=uzi;
  end;
  if l=300 then typ:=-1;
end;

procedure InitMap(menomapy:string);
var f:file of byte;
    i,j,a,b:integer;
    k:integer;
    bb:byte;
begin
 assign(f,menomapy+'.map');
 reset(f);
 for j:=1 to maxy do for i:=1 to 64 do if (i<=maxx) and (j<=maxy) then read(f,mapa[i,j].typ,mapa[i,j].x) else read(f,bb,bb);
 k:=0;
 for i:=1 to maxx do for j:=1 to maxy do
 begin
   walls[i,j]:=mapa[i,j].typ>7;
   if mapa[i,j].x>0 then inc(k);
 end;
 veci:=k;
 k:=k div 4;
 if k=0 then inc(k);
 fillchar(things,sizeof(things),0);
 for i:=1 to k do
 begin
   polozvec(a,b,j);
   if j=-1 then continue;
   things[a,b].who:=who_empty;
   things[a,b].what:=j;
 end;
 nacitaj_obr;
 riadkov:=(15-numberofplayers)*4;
 for i:=1 to riadkov do spravy[i]:='';
 oznam:=true;
 say(15,'Proboj ''99 v1.1');
end;

procedure Say(color:integer;S:String);
var i:integer;
Begin
   for i:=1 to riadkov-1 do spravy[i]:=spravy[i+1];
   spravy[riadkov]:=s;
   for i:=1 to riadkov-1 do cspravy[i]:=cspravy[i+1];
   cspravy[riadkov]:=color;
   oznam:=true;
End;

procedure deton;
var i,q,w,x,y:integer;
begin
   randseed:=1234;
   setwritemode(xorput);
   for i:=1 to 200 do begin
      q:=-15+random(15);
      w:=-15+random(15);
      for x:=1 to maxx do
         for y:=1 to maxy do
            if things[x,y].who=who_empty then
               if things[x,y].what=mine_active  then
                     putpixel(x*15+q,y*15+w,15-getpixel(x*15+q,y*15+w));
      IF OZVUC=1 THEN sound(50+random(50));
      if (i mod 3)=0 then delay(1);
   end;
   randseed:=1234;
   delay(15);
   for i:=1 to 200 do begin
      q:=-15+random(15);
      w:=-15+random(15);
      for x:=1 to maxx do
         for y:=1 to maxy do
            if things[x,y].who=who_empty then
               if things[x,y].what=mine_Active then
                     putpixel(x*15+q,y*15+w,15-getpixel(x*15+q,y*15+w));
      IF OZVUC=1 THEN sound(50+random(50));
      if (i mod 3)=0 then delay(1);
   end;
   IF OZVUC=1 THEN nosound;
   setwritemode(normalput);
end;

procedure mina(x,y:integer);
var i,q,w:integer;
begin
   randseed:=1234;
   setwritemode(xorput);
   for i:=1 to 200 do begin
      q:=-15+random(15);
      w:=-15+random(15);
      putpixel(x*15+q,y*15+w,15-getpixel(x*15+q,y*15+w));
      IF OZVUC=1 then sound(50+random(50));
      if (i mod 2)=0 then delay(1);
   end;
   randseed:=1234;
   delay(15);
   for i:=1 to 200 do begin
      q:=-15+random(15);
      w:=-15+random(15);
      putpixel(x*15+q,y*15+w,15-getpixel(x*15+q,y*15+w));
      IF OZVUC=1 THEN sound(50+random(50));
      if (i mod 2)=0 then delay(1);
   end;
   IF OZVUC=1 then nosound;
   setwritemode(normalput);
end;
procedure Vybuch(x,y:integer);
var i,q,w:integer;
begin
   randseed:=1234;
   setwritemode(xorput);
   for i:=1 to 2000 do begin
      q:=x*15-30+random(45);
      w:=y*15-30+random(45);
      putpixel(q,w,15-getpixel(q,w));
      IF OZVUC=1 then sound(50+random(50));
      if (i mod 5)=0 then delay(1);
   end;
   randseed:=1234;
   delay(15);
   for i:=1 to 2000 do begin
      q:=x*15-30+random(45);
      w:=y*15-30+random(45);
      IF OZVUC=1 then sound(50+random(50));
      putpixel(q,w,15-getpixel(q,w));
      if (i mod 15)=0 then delay(1);
   end;
   IF OZVUC=1 then nosound;
   setwritemode(normalput);
end;

procedure efekt;
var i,x,y:integer;
r:real;
begin
   setwritemode(xorput);
   setcolor(15);
   line (240,0,240,479);
   line (0,240,479,240);
   circle(240,240,200);
   setusercharsize(12,1,12,1);
   settextstyle(1,0,0);
   settextjustify(1,1);
   setlinestyle(0,0,3);
   for i:=5 downto 1 do begin
      randseed:=34;
      for x:=-5 to 5 do
         for y:=-5 to 5 do begin
            setcolor(1+random(15));
            outtextxy(270+x,200+y,chr(48+i));
         end;
      r:=0.5;
      IF OZVUC=1 THEN nosound;
      repeat
         setcolor(1+random(15));
         line(240,240,240+round(200*sin(r)),240-round(200*cos(r)));
         delay(1);
         line(240,240,240+round(200*sin(r)),240-round(200*cos(r)));
         r:=r+0.02;
      until r>6.28;
      IF OZVUC=1 THEN sound(880);
      randseed:=34;
      for x:=-5 to 5 do
         for y:=-5 to 5 do begin
            setcolor(1+random(15));
            outtextxy(270+x,200+y,chr(48+i));
         end;
      if keypressed then i:=1;
   end;
   IF OZVUC=1 then nosound;
   settextjustify(0,2);
   settextstyle(0,0,0);
   line (240,0,240,479);
   line (0,240,479,240);
   circle(240,240,200);
   setwritemode(normalput);
   fillchar(change,sizeof(change),true);
    for i:=1 to numberofplayers do begin
     putimage(549,i*32-32,obrazky[o_uzi],normalput);
     putimage(579,i*32-32,obrazky[o_mine],normalput);
     putimage(609,i*32-32,obrazky[o_bomb],normalput);
 end;

end;

begin
end.