unit MiEro;

interface

uses types,crt;

type tMiEro=object(tPlayer)
               washere : array[1..32,1..32] of integer;
               blind : array[1..32,1..32] of integer;
               obzor : array[-4..4,-4..4] of tsquare;
               nove : array[-4..4,-4..4] of boolean;
               goon : array[-4..4,-4..4] of integer;
               id : integer;
               washere_ok : boolean;
               blind_ok : boolean;
               cas : integer;
               mx,my,r : integer;

               constructor InitGame(MyNumber:integer; var name:string);
               procedure MakeTurn(var move_dx,move_dy,fire,turn_dx,turn_dy:shortint);virtual;

               function PocSused(_x,_y : integer) : integer;
               procedure SearchBlind;
               procedure MoveToBlind;
               procedure FoundHole;
               procedure WasHereInit;
               procedure UpdateObzor;
               procedure UpdateGoOn;
               function MieriaNaMna(var k : integer) : boolean;
               function JeZamerany : boolean;
{               function BerVeci(var i : integer) : boolean;}
              end;
     pMiEro=^tMiEro;

type tFronta = object
                f : array[0..2*MaxX*MaxY] of shortint;
                z,k : integer;
                constructor Init;
                function Pop(var x,y : integer) : boolean;
                procedure Push(x,y : integer);
               end;
     pFronta = ^tFronta;

implementation

const _dx : array[1..8] of shortint = (+1,+1, 0,-1,-1,-1, 0,+1);
      _dy : array[1..8] of shortint = ( 0,-1,-1,-1, 0,+1,+1,+1);
      _cx : array[1..8] of shortint = ( 3, 7, 4, 2, 3, 7, 2, 4);

constructor tFronta.Init;
begin
 z := 0; k := 0;
end;

procedure tFronta.Push;
begin
 f[k] := x; f[k+1] := y;
 inc(k,2); if k > 2*MaxX*MaxY then k := 0;
end;

function tFronta.Pop;
begin
 Pop := (z <> k);
 x := f[z]; y := f[z+1];
 inc(z,2); if z > 2*MaxX*MaxY then z := 0;
end;

constructor tMiEro.InitGame;
var i,j : integer;
begin
 name:='MiEro';
 id := MyNumber;
 blind_ok := false;
 washere_ok := false;
 cas := 0;
 mx := 0; my := 0; r := 1;
 fillchar(blind,sizeof(blind),0);
 fillchar(washere,sizeof(washere),0);
 for i := -4 to 4 do
  for j := -4 to 4 do
   obzor[i,j].who := who_unknown;
end;

function tMiEro.PocSused;
var i,j : integer;
begin
 j := 0;
 if not walls[_x,_y] then
    for i := 1 to 8 do
     if not walls[_x+_dx[i],_y+_dy[i]] then
        inc(j);
 PocSused := j;
end;

procedure tMiEro.SearchBlind;
var f : pFronta;
    i,j,k,vzd : integer;
begin
 new(f,init);
 vzd := 1;
 for i := 1 to 32 do
  for j := 1 to 32 do
   if walls[i,j] then blind[i,j] := maxint;

 for i := 2 to 31 do
  for j := 2 to 31 do
   if PocSused(i,j) = 1 then
      f^.Push(i,j);

 { BFS }
 i := -2; j := -1; f^.Push(i,j);
 while f^.Pop(i,j) do
  begin
   if i < -1 then
      begin
       inc(vzd);
       if f^.z = f^.k then break;
       f^.Push(i,j);
       continue;
      end;
   if blind[i,j] = 0 then
      begin
       blind[i,j] := vzd;
       for k := 1 to 8 do
        if (not walls[i+_dx[k],j+_dy[k]]) and (blind[i+_dx[k],j+_dy[k]] = 0) then
           f^.Push(i+_dx[k],j+_dy[k]);
      end;
  end;
 { BFS end }

 dispose(f);
end;

procedure tMiEro.MoveToBlind;
var i,j : integer;
begin
 j := blind[x,y];
 for i := 1 to 8 do
  if blind[x+_dx[i],y+_dy[i]] < j then break;
 mx := _dx[i]; my := _dy[i];
 r := i;
end;

procedure tMiEro.FoundHole;
var i : integer;
begin
 for i := 1 to 8 do
  if not walls[x+_dx[i],y+_dy[i]] then break;
 r := i;
end;

procedure tMiEro.WasHereInit;
var i,j : integer;
begin
 for i := 1 to 32 do
  for j := 1 to 32 do
   if walls[i,j] then washere[i,j] := maxint;
end;

procedure tMiEro.UpdateObzor;
var i,j : integer;
begin
 fillchar(nove,sizeof(nove),0);
{ if mx = -1 then
  for j := -4 to 4 do
   begin
    for i := 4 downto -3 do
     obzor[i,j] := obzor[i-1,j];
    obzor[-4,j].who := who_unknown;
   end;
 if mx = 1 then
  for j := -4 to 4 do
   begin
    for i := -4 to 3 do
     obzor[i,j] := obzor[i+1,j];
    obzor[4,j].who := who_unknown;
   end;
 if my = -1 then
  for j := -4 to 4 do
   begin
    for i := -4 to 3 do
     obzor[j,i] := obzor[j,i+1];
    obzor[j,4].who := who_unknown;
   end;
 if my = 1 then
  for j := -4 to 4 do
   begin
    for i := 4 downto -3 do
     obzor[j,i] := obzor[j,i-1];
    obzor[j,-4].who := who_unknown;
   end; {}

 for i := -4 to 4 do
  for j := -4 to 4 do
   obzor[i,j].who := who_unknown; {}

 for i := -4 to 4 do
  for j := -4 to 4 do
   if (x+i >= 1) and (x+i <= 32) and (y+j >= 1) and (y+j <= 32) then
{      if (things[x+i,y+j].who <> who_unknown) then}
         begin
          nove[i,j] := true;
          obzor[i,j] := things[x+i,y+j];
         end; {}

end;

procedure tMiEro.UpdateGoOn;
var i,j,k,vzd : integer;
    f : pFronta;
begin
 for i := -4 to 4 do
  for j := -4 to 4 do
   GoOn[i,j] := maxint;
 GoOn[0,0] := 0;

 new(f,Init);
 f^.Push(0,0); vzd := 1;

 { BFS }
 i := -10; j := -10; f^.Push(i,j);
 while f^.Pop(i,j) do
  begin
   if i <= -10 then
      begin
       inc(vzd);
       if f^.z = f^.k then break;
       f^.Push(i,j);
       continue;
      end;
   if ((i < -4) or (i > 4) or (j < -4) or (j > 4)) and (GoOn[i,j] = 0) then
      begin
       GoOn[i,j] := vzd;
       for k := 1 to 8 do
        if (not walls[i+_dx[k],j+_dy[k]]) and (GoOn[i+_dx[k],j+_dy[k]] = 0) then
           f^.Push(i+_dx[k],j+_dy[k]);
      end;
  end;
 { BFS end }

 dispose(f);
end;

function tMiEro.MieriaNaMna;
var i,j : integer;
begin
 MieriaNaMna := false;
 for i := 1 to 8 do
  for j := 1 to 4 do
   if (nove[_dx[i]*j,_dy[i]*j]) and (obzor[_dx[i]*j,_dy[i]*j].who = who_player) then
{   if (x+_dx[i]*j >= 1) and (x+_dx[i]*j <= 32) and
      (y+_dy[i]*j >= 1) and (y+_dy[i]*j <= 32) and
   (things[x+_dx[i]*j,y+_dy[i]*j].who = who_player) then}
      begin
       MieriaNaMna := true;
       k := i;
       exit;
      end;
end;

function tMiEro.JeZamerany;
var j : integer;
begin
 JeZamerany := false;
 for j := 1 to 4 do
  if nove[_dx[r]*j,_dy[r]*j] and (obzor[_dx[r]*j,_dy[r]*j].who = who_player) then
     begin
      if goon[_dx[r]*j,_dy[r]*j] <> j then continue;
      JeZamerany := true;
      exit;
     end;
end;

(*
function tMiEro.BerVeci(var i : integer) : boolean; { NEBERIE }

 function find(a,b : integer) : integer;
 var i : integer;
 begin
  while goon[a,b] <> 2 do
   for i := 1 to 8 do
    if (not walls[x+a+_dx[i],y+b+_dy[i]] ) and (goon[a+_dx[i],b+_dy[i]] < goon[a,b]) then
       begin a := a+_dx[i]; b := b+_dy[i]; break; end;
  find := (i + 3) mod 8 + 1;
 end;

var vzd,a,b : integer;
begin
 BerVeci := false; vzd := maxint; i := 0;
 for a := -4 to 4 do
  for b := -4 to 4 do
   if (obzor[a,b].who = who_empty) and (obzor[a,b].what > 0) then
      begin
       if (lives < 5) and (obzor[a,b].what = booster) and (goon[a,b] - 5 < vzd) then
          begin
           vzd := goon[a,b] - 5;
           i := find(a,b);
          end;
       if (lives < 5) and (obzor[a,b].what = aid) and (goon[a,b] - 3 < vzd) then
          begin
           vzd := goon[a,b] - 3;
           i := find(a,b);
          end;
       if (obzor[a,b].what = uzi) and (goon[a,b] < vzd) then
          begin
           vzd := goon[a,b];
           i := find(a,b);
          end;
       if (obzor[a,b].what = mine) and (goon[a,b] < vzd) then
          begin
           vzd := goon[a,b];
           i := find(a,b);
          end;
       if (obzor[a,b].what = bomb) and (goon[a,b] < vzd) then
          begin
           vzd := goon[a,b];
           i := find(a,b);
          end;
      end;
 if i > 0 then begin BerVeci := true; sound(100); delay(1); nosound; end;
end;
*)
function Int2Str(c : integer) : string;
var s : string;
begin
 Str(c,s); Int2Str := s;
end;

procedure tMiEro.MakeTurn;
var i,j,min : integer;
label podla_zmeny,skryt_sa,koniec;
begin
 if not blind_ok then begin SearchBlind; blind_ok := true; end;
 if not washere_ok then begin WasHereInit; washere_ok := true; end;

 UpdateObzor; UpDateGoOn;
 mx := 0; my := 0; fire := 1;

 if JeZamerany then
    begin
     if rations[uzi] > 0 then fire := uzi
                         else fire := gun;
     goto KONIEC;
    end;

 if MieriaNaMna(i) then
    begin
     r := i;
     fire := gun;
     goto KONIEC;
    end;

{ if BerVeci(i) then
    begin
     mx := _dx[i]; my := _dy[i];
     goto KONIEC;
    end;}


 goto PODLA_ZMENY;

SKRYT_SA:  {***LABEL***}
 if blind[x,y] <> 1 then
     MoveToBlind
 else
    FoundHole;
goto koniec;

PODLA_ZMENY: {***LABEL***}
 inc(cas);
 washere[x,y] := cas;
 min := maxint; j := 0;
 for i := 1 to 8 do
  if washere[x+_dx[i],y+_dy[i]] < min then
     begin
      j := i;
      min := washere[x+_dx[i],y+_dy[i]];
     end;
 mx := _dx[j]; my := _dy[j];
{ inc(r); if r > 8 then r := 1; {}
 r := j;
 if (rations[mine] > 0) and (blind[x,y] < blind[x+mx,y+my]) then
    begin
     fire := mine;
     washere[x+_dx[r],y+_dy[r]] := maxint;
    end;

goto koniec;

 fire:=1;

KONIEC: {***LABEL***}
 move_dx := mx; move_dy := my; turn_dx := _dx[r]; turn_dy := _dy[r];
 died:=false;
end;

begin
end.
