unit sumo;

interface

uses types;

type tSumo=object(tPlayer)
               licznik,aktprio,aktcelx,aktcely,aktruch:integer;

               qgetpos,qputpos:integer;
               q:array[0..1023] of integer;
               bylem,danger,minodl:array[1..32,1..32] of integer;

               ruchy:array[0..7] of record
                                     x,y:integer;
                                    end;


               procedure droga(poczx,poczy,konx,kony:integer; var mvx,mvy:shortint);
               constructor InitGame(MyNumber:integer; var name:string);
               procedure MakeTurn(var move_dx,move_dy,fire,turn_dx,turn_dy:shortint);virtual;
               function qempty:boolean;
               function znajdzcel(var cx,cy:integer):integer;
               function getq:integer;
               procedure putq(el:integer);
               procedure initq;
               procedure initbylem;

              end;
     pSumo=^tSumo;

implementation

procedure tSumo.initbylem;
var px,py:integer;

begin
 for px:=1 to 32 do
 for py:=1 to 32 do
 begin
  if walls[px,py] then bylem[px,py]:=32000
                  else bylem[px,py]:=0;
 end;
end;

constructor tSumo.InitGame;
var px,py:integer;

begin

 initbylem;



 name:='Ufon #3';

 fillchar(danger,sizeof(danger),0);

 aktruch:=0;

 licznik:=32000;

 aktcelx:=x;
 aktcely:=y;
 aktprio:=0;

 initq;

 ruchy[0].x:=1;
 ruchy[0].y:=0;

 ruchy[1].x:=-1;
 ruchy[1].y:=0;

 ruchy[2].x:=0;
 ruchy[2].y:=-1;

 ruchy[3].x:=0;
 ruchy[3].y:=1;

 ruchy[4].x:=-1;
 ruchy[4].y:=-1;

 ruchy[5].x:=1;
 ruchy[5].y:=1;

 ruchy[6].x:=1;
 ruchy[6].y:=-1;

 ruchy[7].x:=-1;
 ruchy[7].y:=1;
end;



function tSumo.qempty:boolean;
begin
 if qgetpos=qputpos then qempty:=true
                    else qempty:=false;
end;

procedure tSumo.initq;
begin
 qgetpos:=0;
 qputpos:=0;
end;

procedure tSumo.putq;
begin
 q[qputpos]:=el;
 qputpos:=(qputpos+1)mod 1024;
end;

function tSumo.getq:integer;
var el:integer;

begin
 el:=q[qgetpos];
 qgetpos:=(qgetpos+1)mod 1024;
 getq:=el;
end;

procedure tSumo.droga(poczx,poczy,konx,kony:integer; var mvx,mvy:shortint);
var pz,px,py,aktx,akty,aktxy:integer;

 procedure mkmove(ax,ay,waga:integer);
 begin
  if (ax<1)or(ax>32)or
     (ay<1)or(ay>32) then exit;

  if walls[ax,ay] then exit;

  if minodl[ax,ay]>waga then
  begin
   minodl[ax,ay]:=waga;
   putq(ax+ay shl 8);
  end;
 end;


begin
 for px:=1 to 32 do
 for py:=1 to 32 do minodl[px,py]:=32000;


 minodl[poczx,poczy]:=0;
 putq(poczx+poczy shl 8);

 while not qempty do
 begin
  aktxy:=getq;
  aktx:=aktxy and 255;
  akty:=aktxy shr 8;

  for pz:=0 to 7 do
  begin
   mkmove(aktx+ruchy[pz].x,akty+ruchy[pz].y,minodl[aktx,akty]+1);
  end;
 end;


 aktx:=konx;
 akty:=kony;

 mvx:=0;
 mvy:=0;

 if minodl[konx,kony]=32000 then exit;

 while (aktx<>poczx)or(akty<>poczy) do
 begin
  for pz:=0 to 7 do
  begin
   px:=aktx+ruchy[pz].x;
   py:=akty+ruchy[pz].y;

   if (px>=1)and(px<=32) and
      (py>=1)and(py<=32) then
   begin
    if minodl[aktx,akty]=minodl[px,py]+1 then
    begin
     mvx:=-ruchy[pz].x;
     mvy:=-ruchy[pz].y;
     aktx:=px;
     akty:=py;
    end;
   end;
  end;
 end;
end;

function tSumo.znajdzcel(var cx,cy:integer):integer;
var px,py,prio:integer;

begin
 prio:=0;

 for px:=x-4 to x+4 do
 for py:=y-4 to y+4 do
 if ((px<>x)or(py<>y))and
    ((px>=1)and(px<=32)and(py>=1)and(py<=32)) then
 begin

  if (things[px,py].who=1)and(prio<1) then
  begin
   prio:=1;

   cx:=px;
   cy:=py;
  end;

  if (things[px,py].what<>nothing)and(prio<2) then
  begin
   prio:=2;

   cx:=px;
   cy:=py;
  end;
 end;

 znajdzcel:=prio;
end;


procedure tSumo.MakeTurn;


 function celuj:boolean;
 var ax,ay,l,poz:integer;

  function sprawdz:boolean;
  begin
   l:=1;

   if walls[ax,ay] then
   begin
    sprawdz:=false;
    exit;
   end;

   ax:=ax+dx;
   ay:=ay+dy;

   while (not walls[ax,ay])and(l<=4) do
   begin
    if (things[ax,ay].who=1)and((ax<>x)or(ay<>y)) then
    begin
     sprawdz:=true;
     exit;
    end;

    inc(l);
    ax:=ax+dx;
    ay:=ay+dy;
   end;

   sprawdz:=false;
  end;


 begin

  for poz:=0 to 7 do
  begin
   move_dx:=ruchy[poz].x;
   move_dy:=ruchy[poz].y;

   ax:=x+move_dx;
   ay:=y+move_dy;

   if sprawdz then
   begin
    celuj:=true;
    exit;
   end;
  end;


  move_dx:=0;
  move_dy:=0;

  celuj:=false;
 end;



 function probojbombe:boolean;
 var px,py:integer;

 begin
  probojbombe:=false;
  if rations[bomb]=0 then exit;

  for px:=x-1 to x+1 do
  for py:=y-1 to y+1 do
  begin
   if (walls[px,py]=true)or(danger[px,py]<>0) then
   begin
    probojbombe:=false;
    exit;
   end;
  end;

  probojbombe:=true;
 end;


 procedure postawbombe;
 var px,py:integer;

 begin
  for px:=x-1 to x+1 do
  for py:=y-1 to y+1 do
  begin
   danger[px,py]:=9;
  end;
 end;



{------------------------------------------------------------}
var najm,l_najm,px,py,prio,cx,cy:integer;

begin
 inc(bylem[x,y]);
 if bylem[x,y]=1000 then initbylem;


 for px:=1 to 32 do
 for py:=1 to 32 do if danger[px,py]>0 then dec(danger[px,py]);


 if celuj then
 begin
  fire:=gun;
  if rations[uzi]>0 then fire:=uzi;

 end else
 begin
  fire:=gun;

  if probojbombe and(random(100)<80) then
  begin
   postawbombe;
   fire:=bomb;
  end;

  repeat
   aktruch:=(aktruch+1)mod 8;
   turn_dx:=ruchy[aktruch].x;
   turn_dy:=ruchy[aktruch].y;
  until walls[x+turn_dx,y+turn_dy]=false;

  {}



  if (aktcelx=x)and(aktcely=y) then
  begin
   aktprio:=0;
   licznik:=32000;
  end;

  prio:=znajdzcel(cx,cy);
  if (prio>aktprio)and(danger[cx,cy]=0) then
  begin
   aktprio:=prio;

   aktcelx:=cx;
   aktcely:=cy;

   licznik:=32000;
  end;

  if aktprio<>0 then
  begin
   droga(x,y,aktcelx,aktcely,move_dx,move_dy);

   if (move_dx=0)and(move_dy=0) then
   begin
    aktprio:=0;
    licznik:=32000;
   end;
  end else
  begin
   inc(licznik);

   if licznik>30 then
   begin
    licznik:=0;
    aktprio:=0;

{    najm:=32000;
    for px:=1 to 32 do
    for py:=1 to 32 do
    if najm>bylem[px,py] then
    begin
     najm:=bylem[px,py];
     l_najm:=1;
    end else
    if najm=bylem[px,py] then
    begin
     inc(l_najm);
    end;

    l_najm:=random(l_najm)+1;
    for px:=1 to 32 do
    for py:=1 to 32 do
    begin
     if bylem[px,py]=najm then
     begin
      dec(l_najm);
      if l_najm=0 then
      begin
       aktcelx:=px;
       aktcely:=py;
      end;
     end;
    end;
 }


    repeat
     aktcelx:=random(32)+1;
     aktcely:=random(32)+1;
    until (walls[aktcelx,aktcely]=false)and(danger[aktcelx,aktcely]=0);
   end;

   droga(x,y,aktcelx,aktcely,move_dx,move_dy);

{   repeat
    move_dx:=shortint(random(3))-1; move_dy:=shortint(random(3))-1;
   until walls[x+move_dx,y+move_dy]=false;}



  end;

 end;


 died:=false;
end;

begin
end.